using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Windows.Forms;
using J4L.Vision;
using J4L.Vision.Util;
using J4L.Vision.Datamatrix;


public class DatamatrixSample {
	
	
	private string[] testSet={ "dm.png","dm2.png","dm3.png","dm4.png","dm5.png","dm6.png","d1.png","d2.png","d3.png","d4.png","d5.png","i7.png","i6.png"};
	//private string[] testSet={ "test.png"};
	
	//private string dir="c:\\a\\vr1\\images\\";
	private string dir="images\\";
	
		
	[STAThread]
	public static void Main(string[] args)
	{
	
		J4L.Vision.Util.SystemProperties.registerAppArgs(args);		
		DatamatrixSample sample=new DatamatrixSample();
		try {
			
			
			sample.runTests();
		} catch (Exception e) {

			Console.WriteLine(e.Message);
			Console.WriteLine(e.StackTrace);
		}
		
		
	}
	
	/**
	 * read all test files
	 *
	 */
	public void runTests() {		
		// these are the default values
		SystemProperties.setProperty("minArea","60");
		SystemProperties.setProperty("maxArea","90000");
		
	 	for (int i=0;i<testSet.GetLength(0);i++) {
			try {
				
				Console.WriteLine("");
				Console.WriteLine("---  ---------------------------");
				Console.WriteLine("Scanning File: "+testSet[i]);
				Console.WriteLine("");
				scanImage(testSet[i]);
				Console.WriteLine("------------------------------");
			} catch (Exception e) {
	 			Console.WriteLine(e.Message);
				Console.WriteLine(e.StackTrace);
			}
		}		
	}
	
	/**
	 * scan file
	 * @param file image file

	 * @throws Exception
	 */
	 public void scanImage(string file)  {
		
		 Bitmap im=(Bitmap) loadImage(dir+file);
	
		DatamatrixReader reader=new DatamatrixReader();
		
	Console.WriteLine("Start "+DateTime.Now);
		RImage rim=new RImage( im);

        DatamatrixData[] barcodes=reader.read(rim);
		rim=null;
		im=null;
		Console.WriteLine("End "+DateTime.Now);		
		if (barcodes.GetLength(0)==0) Console.WriteLine("*** NO BARCODE FOUND ***");
		
		for (int i=0;i<barcodes.GetLength(0);i++) {
			Console.WriteLine("Barcode  found "+barcodes[i].toString());
			
		}
						
	}
	
	/**
	 * load image from file
	 */
	public Image loadImage(String f) {
			
	 	Image bp= Bitmap.FromFile(f);
	 	Bitmap b2=new Bitmap(bp.Width,bp.Height,PixelFormat.Format24bppRgb);
	 	Graphics g=Graphics.FromImage(b2);
	 	g.DrawImage(bp,0,0,bp.Width,bp.Height);
	 	g.Dispose();
	 	return b2;

	}	
}
